﻿using Blazor.Models;
using Blazor.Services;
using Microsoft.AspNetCore.Components;
using static Blazor.Pages.Questions.AddQuestion;

namespace Blazor.Pages.Questions
{
    public partial class EditQuestion
    {

        [Parameter]
        public int Id { get; set; }

        private QuestionModel? questionModel;

        [Inject]
        public required IDataService DataService { get; set; }

        [Inject]
        public required NavigationManager NavigationManager { get; set; }

        [Inject]
        public required IWebHostEnvironment WebHostEnvironment { get; set; }

        [Inject]
        public required ILogger<EditQuestion> Logger { get; set; }

        protected override async Task OnInitializedAsync()
        {
            var question = await DataService.GetQuestionById(Id);

            questionModel = new QuestionModel
            {
                Id = question.Id,
                Content = question.Content
            };
        }
        private async Task HandleValidSubmit()
        {
            await DataService.Update(Id, questionModel);

            var formData = new List<KeyValuePair<string, string>>();
            formData.Add(new KeyValuePair<string, string>("content", questionModel.Content));
            formData.Add(new KeyValuePair<string, string>("idchapter", questionModel.IdChapter.ToString()));
            //foreach (var answerModel in answerModels)
            //{
            //    var answercontent = $"answerContent{answerModel.Id + 1}";
            //    formData.Add(new KeyValuePair<string, string>(answercontent, answerModel.Content));
            //}
            //foreach (var checkbox in checkboxs)
            //{
            //    if (checkbox.IsCorrect != false)
            //    {
            //        var idgood = checkbox.Id + 1;
            //        formData.Add(new KeyValuePair<string, string>("idanswergood", idgood.ToString()));
            //    }
            //}

            var formContent = new FormUrlEncodedContent(formData);

            string apiUri = API.API_URL+"/update/questions/" + questionModel.Id + "/" + API.TOKEN;

            using (var httpClient = new HttpClient())
            {
                var response = await httpClient.PostAsync(apiUri, formContent);

                if (response.IsSuccessStatusCode)
                {
                    var responseBody = await response.Content.ReadAsStringAsync();
                }
                else
                {
                    var errorResponse = await response.Content.ReadAsStringAsync();
                }
            }

        }
    }
}
